abuild.in 19.9 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
Natanael Copa's avatar
Natanael Copa committed
13 14 15

startdir="$PWD"
srcdir=${srcdir:-"$startdir/src"}
16
pkgbasedir=${pkgbasedir:-"$startdir/pkg"}
Natanael Copa's avatar
Natanael Copa committed
17
pkgrel=0
Natanael Copa's avatar
Natanael Copa committed
18 19
repo=${startdir%/*}
repo=${repo##*/}
20
tmprepo=/var/cache/abuild/tmprepo
Natanael Copa's avatar
Natanael Copa committed
21 22 23 24

# defaults
SRCDEST=${SRCDEST:-$startdir}
PKGDEST=${PKGDEST:-$startdir}
25
BUILD_BASE="binutils gcc make patch uclibc-dev"
Natanael Copa's avatar
Natanael Copa committed
26

27 28
SUDO=${SUDO:-"sudo"}

29
default_cmds="sanitycheck builddeps clean fetch unpack rootpkg"
Natanael Copa's avatar
Natanael Copa committed
30

Natanael Copa's avatar
Natanael Copa committed
31
# read config
Natanael Copa's avatar
Natanael Copa committed
32
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
33 34
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

35
# source functions
36 37
datadir=/usr/share/abuild

Natanael Copa's avatar
Natanael Copa committed
38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69
#colors
if [ -n "$USE_COLORS" ]; then
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
70 71

	
Linux User's avatar
Linux User committed
72 73
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
74
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
75 76 77 78 79
	fi
} 

cleanup() {
	set_xterm_title ""
80
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
81
		$SUDO apk del $uninstall_after
82
	fi
Linux User's avatar
Linux User committed
83 84
}

Natanael Copa's avatar
Natanael Copa committed
85
die() {
Linux User's avatar
Linux User committed
86
	error "$@"
Linux User's avatar
Linux User committed
87
	cleanup
Natanael Copa's avatar
Natanael Copa committed
88 89 90
	exit 1
}

91 92
# check if apkbuild is basicly sane
sanitycheck() {
Natanael Copa's avatar
Natanael Copa committed
93
	local i
94
	msg "Checking sanity of $APKBUILD..."
95 96 97
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
98
	[  "${pkgver##[0-9]}" == "$pkgver" ] && \
99 100 101 102 103 104
		die "pkgver does not start with a digit"
	[ -z "$pkgrel" ] && warning "Missing pkgrel in APKBUILD. Using pkgrel=0"
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

105 106 107
	if [ -n "$source" ]; then
		for i in $source; do
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
108 109 110
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
111 112
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
113

114 115 116 117 118
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
			source_has $i || die "$i is missing in source"
		done
	fi
119

120 121 122
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
123 124

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
125 126 127 128
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
129
	local dummy f
130 131 132
	if [ -z "$source" ]; then
		return 0
	fi
133
	if [ -z "$md5sums" ]; then
134
		die "Use 'abuild checksum' to generate/update the checksum(s)"
135
	fi
136 137 138
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
139
	fetch || return 1
140
	msg "Checking md5sums..."
141
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
142 143 144 145 146
}

uri_fetch() {
	local uri="$1"
	local d="${s##*/}"	# $(basename $s)
147 148 149 150
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

151 152 153 154 155 156
	
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
157
	mkdir -p "$SRCDEST"
158 159 160
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
161
	fi
Linux User's avatar
Linux User committed
162
	msg "Fetching $uri"
163 164
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
165 166
}

167 168
is_remote() {
	case "$1" in
169
		http://*|ftp://*|https://*)
170 171 172 173 174
			return 0;;
	esac
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
175 176 177
fetch() {
	local s
	mkdir -p "$srcdir"
178 179 180 181 182 183 184
	for s in $source; do
		if is_remote "$s"; then
			uri_fetch "$s" || return 1
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
185 186 187 188 189 190
	done
}

# unpack the sources
unpack() {
	local u
191
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
192 193 194 195
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
196
			*.tar.gz|*.tgz)
197
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
198 199
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
200
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
201
				tar -C "$srcdir" -jxf "$s" || return 1;;
202 203 204 205
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
Natanael Copa's avatar
Natanael Copa committed
206 207 208
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
209 210 211 212 213 214
		esac
	done
}

# cleanup source and package dir
clean() {
215
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
216
	rm -rf "$srcdir"
217
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
218 219 220 221 222 223
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
224 225 226 227
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
228 229 230 231 232
	done
}

cleanpkg() {
	local i
233
	msg "Cleaning built packages..."
234
	for i in $pkgname $subpackages; do
235
		local p="$i-$pkgver-r$pkgrel"
236
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz"
Natanael Copa's avatar
Natanael Copa committed
237 238 239
	done
}

240 241 242 243 244 245 246 247 248 249 250 251 252
# clean all packages except current
cleanoldpkg() {
	local i j
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
	
Natanael Copa's avatar
Natanael Copa committed
253 254
runpart() {
	local part=$1
255
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
256 257 258 259 260 261 262 263
	$part || die "$part failed"
}

# override those in your build script
build() {
	die "No build() function found in $APKBUILD"
}

264 265 266 267 268 269 270 271 272
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

273
prepare_subpackages() {
274
	if [ -z "$subpackages" ]; then
275 276
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
277 278
	local i
	cd "$startdir"
279
	for i in $subpackages; do
280 281
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
282
		msg "Running split function $func..."
283
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
284
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
285 286 287
	done
}

288
prepare_metafiles() {
289 290
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
291
	local dir=${subpkgdir:-$pkgdir}
292
	local pkg="$name-$pkgver-r$pkgrel.apk"
293
	local sub
Natanael Copa's avatar
Natanael Copa committed
294 295 296 297 298 299
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

300
	echo "# Generated by $(basename $0) $abuild_ver" >.PKGINFO
Natanael Copa's avatar
Natanael Copa committed
301 302 303 304 305
	if [ -n "$FAKEROOTKEY" ]; then
		echo "# using $(fakeroot -v)" >> .PKGINFO
	fi
	echo "# $(date -u)" >> .PKGINFO
	cat >> .PKGINFO <<EOF
306
pkgname = $name
307
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
308 309 310 311 312 313
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
314 315
	local i deps
	deps="$depends"
316 317 318 319 320 321 322 323
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
		for i in $install; do
			if head -n 1 "$srcdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
324 325
	fi
	
Natanael Copa's avatar
Natanael Copa committed
326 327 328 329 330 331
	for i in $license; do
		echo "license = $i" >>.PKGINFO
	done
	for i in $replaces; do
		echo "replaces = $i" >>.PKGINFO
	done
332
	for i in $deps; do
Natanael Copa's avatar
Natanael Copa committed
333 334 335 336 337 338 339 340 341 342 343 344 345
		echo "depend = $i" >>.PKGINFO
	done
	for i in $conflicts; do
		echo "conflict = $i" >>.PKGINFO
	done
	for i in $provides; do
		echo "provides = $i" >>.PKGINFO
	done
	for i in $backup; do
		echo "backup = $i" >>.PKGINFO
	done

	local metafiles=".PKGINFO"
346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363
	for i in $install; do
		script=${i#$name}
		case "$script" in
			.install)
				warning "Deprecated .install script found."
				script=.INSTALL
				;;
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall)
				msg "Adding $script"
				;;
			*) 	error "$script: Invalid install script"
				return 1
				;;
		esac
		cp "$srcdir/$i" "$dir/$script" || return 1
		chmod +x "$dir/$script"
		metafiles="$metafiles $script"
	done
364 365 366
	echo $metafiles | tr ' ' '\n' > "$dir"/.metafiles

	find -name '*.so' | sed 's:.*/::' >"$dir"/.provides-so
Natanael Copa's avatar
Natanael Copa committed
367 368
}

369
prepare_package() {
370
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
371
	options_has "!strip" ||	stripbin
372 373 374 375 376 377 378 379 380 381 382
	prepare_metafiles
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

create_apks() {
	local file
383
	for file in "$pkgbasedir"/*/.PKGINFO; do
384 385 386
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
387
		local apk=$name-$ver.apk
388 389 390
		(
		set *
		[ "$1" = '*' ] && set --
391
		cd "$dir" && tar -zcf "$PKGDEST"/$apk $(cat .metafiles) $@
392 393
		)
	done
Natanael Copa's avatar
Natanael Copa committed
394 395
}

396 397 398 399 400 401 402 403 404 405 406 407 408 409
update_tmprepo() {
	if ! up2date; then
		sanitycheck && builddeps && clean && fetch && unpack && rootpkg || return 1
	fi
	local apk
	for apk in $(listpkg); do
		ln -sf "$PKGDEST"/$apk "$tmprepo"/$apk
	done

	# update the tmprepo cache here
	msg "Updating the cached build repository index..."
	apk index "$tmprepo"/*.apk | gzip > "$tmprepo"/APK_INDEX.gz
}

410
# predefined splitfunc doc
411
default_doc() {
412
	depends="$depends_doc"
413
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
414
	local i
415
	for i in doc man info html sgml licenses gtk-doc; do
416 417 418
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
419 420
		fi
	done
421 422 423
	
	rm -f "$subpkgdir/usr/share/info/dir"

424 425 426
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
427 428 429 430

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
431
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
432 433 434
	return 0
}

435 436 437 438
doc() {
	default_doc
}

439
# predefined splitfunc mod
440
default_mod() {
441
	depends="$kernel $depends_mod"
442
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
443
	for i in firmware modules; do
444 445 446
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
447
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
448 449 450 451
		fi
	done
}

452 453 454 455
mod() {
	default_mod
}

456
# predefined splitfunc dev
457
default_dev() {
458
	depends="$pkgname $depends_dev"
459
	install="$install_dev"
460
	cd "$pkgdir" || return 0
461 462 463 464 465
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
466 467
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
468
			mkdir -p "$d"
469
			mv "$pkgdir/$i" "$d"
470
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
471 472
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
473
	return 0
Natanael Copa's avatar
Natanael Copa committed
474 475
}

476 477 478 479
dev() {
	default_dev
}

Natanael Copa's avatar
Natanael Copa committed
480 481
# build and package in fakeroot
rootpkg() {
Natanael Copa's avatar
Natanael Copa committed
482
	cd "$startdir"
483
	msg "Entering fakeroot..."
484
	fakeroot $0 build prepare_subpackages prepare_package create_apks
Natanael Copa's avatar
Natanael Copa committed
485 486 487
}

srcpkg() {
488
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
489
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
490 491 492 493 494
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
495
	msg "Creating source package $p.src.tar.gz..."
496
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
497 498
}

499 500
# check if package is up to date
up2date() {
501
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
502
	local i s
Natanael Copa's avatar
Natanael Copa committed
503
	cd "$startdir"
504 505 506 507 508
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

509
	for i in $source APKBUILD; do
510 511 512 513 514 515
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
516 517 518 519 520 521 522
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

523 524 525 526 527 528 529 530 531 532 533 534 535
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/../..)
	for i in $aportsdir/*/*/APKBUILD; do
		pkgname=
		subpackages=
		depends=
		makedepends=
536
		. $i
537
		dir=${i%/APKBUILD}
538 539 540 541 542 543 544 545
		deps=
		# filter out conflicts from deps
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
			deps="$deps $j"
		done
546
		for j in $pkgname $subpackages; do
547
			echo "o ${j%%:*} $dir"
548
			set -- $deps
549 550 551 552 553 554 555
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
556 557
		done
	done
558
	)
559 560
}

561
deptrace() {
562 563
	local deps="$@"
	[ -z "$deps" ] && deps="$BUILD_BASE $depends $makedepends"
564 565 566
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
Natanael Copa's avatar
Natanael Copa committed
567
			apk info -q | sort |  sed 's/^/i /'
568
		fi
569
	) | awk -v pkgs="$deps" '
570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
595 596
	local deps alldeps pkg i dir ver missing installed_deps
	msg "Analyzing dependencies..."
597 598
	deps="$BUILD_BASE $makedepends"

599

600 601 602 603 604
	# add depends unless it is a subpackage
	for i in $depends; do
		subpackages_has $i || deps="$deps $i"
	done

605
	installed_deps=$(apk info -e $deps)
606
	# find which deps are missing
607
	for i in $deps; do
608
		if [ "${i#\!}" != "$i" ]; then
609
			list_has ${i#\!} $installed_deps \
610
				&& die "Conflicting package ${i#\!} is installed."
611
		elif ! list_has $i $installed_deps; then
612 613 614 615 616 617 618 619 620 621 622
			if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
				die "Missing dependency $i. Use -r to autoinstall or -R to build"
			fi
			missing="$missing $i"
		fi
	done

	[ -z "$missing" ] && return 0

	if [ -n "$install_deps" ] &&  $SUDO apk add $missing; then
		uninstall_after="$missing $uninstall_after"
623 624
		return 0
	fi
625 626 627 628
	
	[ -z "$recursive" ] && return 1
	
	for i in $(deptrace $missing); do
629 630 631 632 633
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
		msg "Entering $dir"
		cd "$dir" || return 1
634
		$0 -k -i $pkg || return 1
635
		uninstall_after="$pkg $uninstall_after"
636 637 638
	done
}

639
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
640 641
checksum() {
	local s files
642
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
643
	fetch
644
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
645 646 647 648
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
649 650
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
651 652
}

653
stripbin() {
654
	local bin
655 656
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
657
	find . -type f 2>/dev/null | while read bin; do
658 659 660 661 662 663 664 665 666 667 668
		local opt=
		case "$(file -biz "$bin")" in
			*/x-sharedlib*|*/x-archive*)
				strip --strip-debug "$bin";;
			*/x-executable*)
				strip "$bin";;
		esac
	done
	return 0
}

669 670 671 672 673 674 675 676
# simply list target apks
listpkg() {
	local i 
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
677 678 679 680 681 682 683 684
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
685 686 687 688 689 690 691 692
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

693 694 695 696 697 698 699 700 701 702 703 704 705 706 707
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

options_has() {
	list_has "$1" $options
}

708 709 710 711
depends_has() {
	list_has "$1" $depends
}

712 713 714 715
makedepends_has() {
	list_has "$1" $makedepends
}

Natanael Copa's avatar
Natanael Copa committed
716 717 718 719
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
720 721 722 723 724 725 726 727 728 729 730 731 732 733
# install package after build
post_add() {
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
	deps=$(apk index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
734
	$SUDO apk add -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
Natanael Copa committed
735 736
}

737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759
# create new aport from templates
newaport() {
	local pn=${newname%-[0-9]*}
	local pv
	if [ "$pn" != "$newname" ]; then
		pv=${newname#$pn-}
	fi
	if [ -e "$pn"/APKBUILD ]; then
		error "$pn/APKBUILD already exist"
		return 1
	fi
	mkdir -p "$pn"
	cd "$pn"
	sed 	-e '1,/^\#*$/d' \
		-e "s/^\(# Contributor: \).*/\1$PACKAGER/" \
		-e "s/^\(# Maintainer: \).*/\1$PACKAGER/" \
		-e "s/^pkgname=.*/pkgname=$pn/" \
		-e "s/^pkgver=.*/pkgver=$pv/" \
		"$datadir"/sample.APKBUILD > APKBUILD || return 1
	#-e '1,/^\#$/d' \
	if [ -n "$cpinitd" ]; then
		cp "$datadir"/sample.initd $pn.initd
		cp "$datadir"/sample.confd $pn.confd
760 761 762
		cp "$datadir"/sample.pre-install $pn.pre-install
		cp "$datadir"/sample.post-install $pn.post-install
		sed -i -e "s/^install=.*/install=\"\$pkgname.pre-install \$pkgname.post-install\"/" \
763 764 765 766 767
			-e "s/^source=\"\(.*\)\"/source=\"\1\n\t$pn.initd\n\t$pn.confd\n\t\$install\n\t\"/" \
			APKBUILD
		
	fi
}
768 769 770 771 772 773 774 775

installdeps() {
	sudo apk add $depends $makedepends
}

uninstalldeps (){
	sudo apk del $depends $makedepends
}
776
	
Natanael Copa's avatar
Natanael Copa committed
777
usage() {
778
	echo "$(basename $0) $abuild_ver"
779 780
	echo "usage: ${0##*/} [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
	echo "              [-s SRCDEST] [cmd] ..."
781
	echo "       ${0##*/} [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
782 783
	echo "Options:"
	echo " -f  Force specified cmd, even if they are already done"
784 785
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
786
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
787
	echo " -p  Set package destination directory"
788
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
789
	echo " -q  Quiet"
790 791
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
792
	echo " -s  Set source package destination directory"
793
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
794
	echo ""
795 796 797
	echo " -n  Create a new APKBUILD in a directory named PKGNAME"
	echo " -c  Copy a sample init.d, conf.d and install script to new directory"
	echo ""
Natanael Copa's avatar
Natanael Copa committed
798
	echo "Commands:"
799
	echo "  checksum    Generate checksum to be included in APKBUILD"
800 801 802 803 804
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
805
	echo "  listpkg     List target packages"
806 807 808
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
809
	echo "  cleanoldpkg Remove binary packages except current version"
810 811 812 813
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
814 815
	echo "  installdeps Install packages listed in makedepends and depends"
	echo "  uninstalldeps Uninstall packages listed in makedepends and depends"
Natanael Copa's avatar
Natanael Copa committed
816 817 818 819 820
	echo ""
	exit 0
}

APKBUILD="${APKBUILD:-./APKBUILD}"
821 822
unset force
unset recursive
823
while getopts "cfhi:kin:p:P:qrRs:u" opt; do
Natanael Copa's avatar
Natanael Copa committed
824
	case $opt in
825
		'c') cpinitd=1;;
Natanael Copa's avatar
Natanael Copa committed
826
		'f') force=1;;
827 828
		'h') usage;;
		'i') install_after="$install_after $OPTARG";;
829
		'k') keep=1;;
830
		'n') newname=$OPTARG;;
831
		'p') PKGDEST=$OPTARG;;
832
		'P') REPODEST=$OPTARG;;
Natanael Copa's avatar
Natanael Copa committed
833
		'q') quiet=1;;
834 835
		'r') install_deps=1;;
		'R') recursive=1;;
836
		's') SRCDEST=$OPTARG;;
837 838
		'u') upgrade=1
		     recursive=1;;
Natanael Copa's avatar
Natanael Copa committed
839 840 841 842
	esac
done
shift $(( $OPTIND - 1 ))

843 844 845 846 847
# If REPODEST is set then it will override the PKGDEST
if [ -n "$REPODEST" ]; then
	PKGDEST="$REPODEST/$repo"
fi

848
# source the buildfile
849 850 851 852
if [ -z "$newname" ]; then
	[ -f "$APKBUILD" ] || die "Could not find $APKBUILD (PWD=$PWD)"
	. "$APKBUILD"
fi
853

854
# If we are handling a sub package then reset subpackages and install
855 856
if [ -n "$subpkgname" ]; then
	subpackages=
857
	install=
858
fi
859
pkgdir="$pkgbasedir/$pkgname"
Natanael Copa's avatar
Natanael Copa committed
860 861

trap 'die "Aborted by user"' INT
Linux User's avatar
Linux User committed
862
set_xterm_title "abuild: $pkgname"
Natanael Copa's avatar
Natanael Copa committed
863

864 865 866
if [ -z "$1" ] && [ -n "$newname" ]; then
	set "newaport"
fi
Natanael Copa's avatar
Natanael Copa committed
867 868

if [ -z "$1" ]; then
Natanael Copa's avatar
Natanael Copa committed
869
	if up2date && [ -z "$force" ]; then
Natanael Copa's avatar
Natanael Copa committed
870
		msg "Package is up to date"
871 872 873
	else
		set $default_cmds
	fi
Natanael Copa's avatar
Natanael Copa committed
874 875 876 877 878 879
fi

while [ $# -gt 0 ]; do
	runpart $1
	shift
done
880 881

for i in $install_after; do
Natanael Copa's avatar
Natanael Copa committed
882
	post_add $i
883 884
done

Linux User's avatar
Linux User committed
885
cleanup
Natanael Copa's avatar
Natanael Copa committed
886